unit TestPlugin1;

interface
uses
  Windows,
  DatulaApi;

  function DatulaPlugin_Init: boolean; stdcall;
  function DatulaPlugin_Exit: boolean; stdcall;
  procedure DatulaPlugin_OnUpdateView; stdcall;
  procedure DatulaPlugin_OnActivate(hWnd: THandle; nState: Cardinal; bMinimized: boolean); stdcall;
  procedure DatulaPlugin_OnNewPostmanInstance(hWnd: THandle); stdcall;
  procedure DatulaPlugin_OnDeletePostmanInstance(hWnd: THandle); stdcall;
  function DatulaPlugin_GetPluginVersion: cardinal; stdcall;

implementation

procedure doSomething;
var
  frameWnd, folderTree, focusBox, messageList, headerPane, viewer:THandle;
begin
  getMainWindow(frameWnd, folderTree, focusBox, messageList, headerPane, viewer);
  MessageBox(frameWnd, 'Do something!', 'Test', MB_OK);
end;

function DatulaPlugin_Init: boolean;
var
  info: TPLUGININFO;
begin
  //Called when DLL is loaded.
  //if (!api.init())
  //        return false;

  //Register plugin-info
  info.sizeofStruct := sizeof (TPLUGININFO);
  info.title := 'Title';
  info.version := 'Version';
  info.author := 'Author';
  registerPluginInfo(hInstance, info);

  //Append menu item if you need.
  DatulaApi.appendMenu('Test', doSomething);
  result := true;
end;

function DatulaPlugin_Exit: boolean;
begin
  //Called when DLL is unloaded.

  //If you appended the menu item, you must delete it.
  deleteMenu(doSomething);
  result := true;//If you are busy, you may return false;
end;

procedure DatulaPlugin_OnUpdateView;
var
  header, body: string;
begin
  //Called when the document is updated.
  //This is equivalent to CView::OnUpdate.

  //You can get the header, which is decoded.
  header := GetHeaderText;
  if Pos( 'AONO', header ) > 0 then
    MessageBeep( $ffffffff );

  //You can get the body, which is decoded.
  body := GetBodyText;
end;

procedure DatulaPlugin_OnActivate(hWnd: THandle; nState: Cardinal; bMinimized: boolean);
begin
  //Called when the main frame or postman frame are activated.
  //hWnd: The handle of the window which is activated.
  //nState: WA_INACTIVE/WA_ACTIVE/WA_CLICKACTIVE
  //bMinimized: The window is iconified.
end;

procedure DatulaPlugin_OnNewPostmanInstance(hWnd: THandle);
begin
  //Called when Postman is created.
end;

procedure DatulaPlugin_OnDeletePostmanInstance(hWnd: THandle);
begin
  //Called when Postman is deleted.
end;

function DatulaPlugin_GetPluginVersion: cardinal;
begin
  //Called at anytime.
  result := $1000001;//means version 1.00.00.01
end;

end.
